Namespace SSTP.Core

    ''' <summary>
    ''' FMONX
    ''' </summary>
    ''' <remarks></remarks>
    Public Class FMO
        Implements IDisposable

        'TrueɂƃC~fBGCgEChEɃfobOpf[^\
        Private Const DEBUG_MODE As Boolean = True

        't@C}bvAPI錾
        Private Declare Function CreateFileMapping Lib "kernel32" Alias "CreateFileMappingA" (ByVal hFile As Integer, ByVal lpFileMappigAttributes As Integer, ByVal flProtect As Integer, ByVal dwMaximumSizeHigh As Integer, ByVal dwMaximumSizeLow As Integer, ByVal lpName As String) As Integer
        Private Declare Function OpenFileMapping Lib "kernel32.dll" Alias "OpenFileMappingA" (ByVal dwDesiredAccess As Integer, ByVal bInheritHandle As Integer, ByVal lpName As String) As Integer
        Private Declare Function CloseHandle Lib "kernel32.dll" (ByVal hObject As Integer) As Integer
        Private Declare Function MapViewOfFile Lib "kernel32.dll" (ByVal hFileMappingObject As Integer, ByVal dwDesiredAccess As Integer, ByVal dwFileOffsetHigh As Integer, ByVal dwFileOffsetLow As Integer, ByVal dwNumberOfBytesToMap As Integer) As Integer
        Private Declare Function UnmapViewOfFile Lib "kernel32.dll" (ByVal lpBaseAddress As Integer) As Integer
        'MutexAPI錾
        Private Declare Function CreateMutex Lib "kernel32" Alias "CreateMutexA" (ByVal lpMutexAttributes As Integer, ByVal bInitialOwner As Integer, ByVal lpName As String) As Integer
        Private Declare Function ReleaseMutex Lib "kernel32" (ByVal hMutex As Integer) As Integer
        Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Integer, ByVal dwMilliseconds As Integer) As Integer
        '[uAPI錾
        Private Declare Sub MoveMemoryGet Lib "kernel32" Alias "RtlMoveMemory" (ByVal Dest As Byte(), ByVal SourcePtl As Integer, ByVal length As Integer)
        Private Declare Sub MoveMemoryPut Lib "kernel32" Alias "RtlMoveMemory" (ByVal SourcePtl As Integer, ByVal Dest As Byte(), ByVal length As Integer)

        ' t@Cr[ɕی쑮萔̐錾
        Private Const PAGE_READWRITE As Integer = &H4
        ' IuWFNgɑ݂Ă邱Ƃ萔̐錾
        Private Const ERROR_ALREADY_EXISTS As Short = 183
        ' IuWFNgւ̃ANZX̃^Cv萔̐錾
        Private Const SECTION_MAP_WRITE As Integer = &H2
        Private Const SECTION_MAP_READ As Integer = &H4
        Private Const FILE_MAP_WRITE As Integer = SECTION_MAP_WRITE
        Private Const FILE_MAP_READ As Integer = SECTION_MAP_READ
        ' ^CAEgiMuteX̃G[R[hj
        Private Const WAIT_TIMEOUT As Integer = &H102

        ' FMȌl
        Private Const FMO_DEF_NAME As String = "Sakura"

        ' ̃IuWFNgQƂFMO
        Private m_FMOName As String = ""

        ' FMObNɎgpnh
        Private m_LockHandle As Integer

        '------------------------
        ' RXgN^
        '------------------------

        ''' <summary>RXgN^</summary>
        ''' <param name="fmoName">QƂFMO̖O</param>
        ''' <remarks></remarks>
        Public Sub New(Optional ByVal fmoName As String = FMO_DEF_NAME)
            m_FMOName = fmoName.Trim
            If m_FMOName.Length = 0 Then
                m_FMOName = FMO_DEF_NAME
            End If
        End Sub

        ''' <summary>fXgN^</summary>
        ''' <remarks></remarks>
        Public Sub Dispose() Implements System.IDisposable.Dispose
            UnlockFMO()
        End Sub

        '------------------------
        ' pubNtB[h
        '------------------------

        ''' <summary>
        ''' ̃IuWFNgQƂFMOB
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public ReadOnly Property FMOName() As String
            Get
                Return m_FMOName
            End Get
        End Property

        '------------------------
        ' pubN\bh
        '------------------------

        ''' <summary>FMÕf[^𕶎f[^ƂĎ荞݂܂B</summary>
        ''' <param name="fmoData">ϐQƓnBʂɊi[B</param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Function ReadFMO(ByRef fmoData As String) As Boolean
            Dim iFileMapOpenHandle As Integer = 0
            Dim iFileMapViewAddress As Integer = 0
            Dim bytesData(65535) As Byte
            fmoData = ""
            Try
                iFileMapOpenHandle = OpenFileMapping(FILE_MAP_READ Or FILE_MAP_WRITE, 0, m_FMOName)
                If iFileMapOpenHandle <> 0 Then
                    iFileMapViewAddress = MapViewOfFile(iFileMapOpenHandle, FILE_MAP_READ, 0, 0, 0)
                    If iFileMapViewAddress <> 0 Then
                        MoveMemoryGet(bytesData, iFileMapViewAddress, 65536)
                        fmoData = convertFMO_Byte2Sjis(bytesData)
                        If DEBUG_MODE Then Debug.Print("FMO[" & m_FMOName & "]:Ǎ")
                    End If
                    ReadFMO = True
                End If
            Catch ex As Exception
                If DEBUG_MODE Then Debug.Print("FMO[" & m_FMOName & "]:Ǎ:" & ex.Message)
                ReadFMO = False
            Finally
                If iFileMapViewAddress <> 0 Then UnmapViewOfFile(iFileMapViewAddress)
                If iFileMapOpenHandle <> 0 Then CloseHandle(iFileMapOpenHandle)
            End Try
        End Function

        ''' <summary>f[^FMÕf[^Ƃďo܂B</summary>
        ''' <param name="fmoData">ϐQƓnBi[B</param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Function WriteFMO(ByVal fmoData As String) As Boolean
            Dim iFileMapOpenHandle As Integer = 0
            Dim iFileMapViewAddress As Integer = 0
            Dim bytesData(65535) As Byte
            Try
                iFileMapOpenHandle = OpenFileMapping(FILE_MAP_READ Or FILE_MAP_WRITE, 0, m_FMOName)
                If iFileMapOpenHandle <> 0 Then
                    iFileMapViewAddress = MapViewOfFile(iFileMapOpenHandle, FILE_MAP_READ Or FILE_MAP_WRITE, 0, 0, 0)
                    If iFileMapViewAddress <> 0 Then
                        bytesData = convertFMO_Sjis2Byte(fmoData)
                        MoveMemoryPut(iFileMapViewAddress, bytesData, 65536)
                        If DEBUG_MODE Then Debug.Print("FMO[" & m_FMOName & "]:o")
                    End If
                    WriteFMO = True
                End If
            Catch ex As Exception
                If DEBUG_MODE Then Debug.Print("FMO[" & m_FMOName & "]:os:" & ex.Message)
                WriteFMO = False
            Finally
                If iFileMapViewAddress <> 0 Then UnmapViewOfFile(iFileMapViewAddress)
                If iFileMapOpenHandle <> 0 Then CloseHandle(iFileMapOpenHandle)
            End Try
        End Function

        ''' <summary>FMÕbNs܂B</summary>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Function LockFMO() As Boolean
            Dim l As Integer
            '݂錮ǂ̃`FbN
            l = CreateMutex(0, 0, m_FMOName & "FMO") 'MuteX擾BO[SakuraFMO]B
            If l = 0 Then Return False '擾sdd
            Try
                If WaitForSingleObject(l, 2000) = WAIT_TIMEOUT Then
                    '^CAEgB
                    If DEBUG_MODE Then Debug.Print("FMO[" & m_FMOName & "]bNs:^CAEg")
                    ReleaseMutex(l)
                    CloseHandle(l)
                    Return False
                End If
                '擾
                m_LockHandle = l
                If DEBUG_MODE Then Debug.Print("FMO[" & m_FMOName & "]bNB")
                Return True
            Catch ex As Exception
                If DEBUG_MODE Then Debug.Print("FMO[" & m_FMOName & "]bNs:" & ex.Message)
                ReleaseMutex(l)
                CloseHandle(l)
                Return False
            End Try
        End Function

        ''' <summary>FMÕAbNs܂BDisposeɂĂ΂܂</summary>
        ''' <returns>(ɐBAbNΏۂȂĂƂ)</returns>
        ''' <remarks></remarks>
        Public Function UnlockFMO() As Boolean
            If m_LockHandle <> 0 Then
                ReleaseMutex(m_LockHandle)
                CloseHandle(m_LockHandle)
                If DEBUG_MODE Then Debug.Print("FMO[" & m_FMOName & "]AbNB")
            End If
            m_LockHandle = 0
            Return True
        End Function

        '------------------------
        ' vCx[g֐
        '------------------------

        'FMOɊi[邽߂ɕf[^oCgf[^ɕϊ
        Private Function convertFMO_Sjis2Byte(ByVal stringData As String) As Byte()
            Dim bytesData As Byte()
            bytesData = System.Text.Encoding.GetEncoding(932).GetBytes("    " & stringData & " ")
            Dim max As Integer = 1024 * 64
            If bytesData.Length > max Then
                ReDim Preserve bytesData(max - 1)
            Else
                max = bytesData.Length
            End If
            bytesData(max - 1) = 0
            bytesData(0) = 0 '{͂̂SoCgɂFMOf[^̃TCY邪
            bytesData(1) = 0 'SSPƂƂɂ͏&H00 01 00 00 B܂A
            bytesData(2) = 1 'f߂sakuraFMO̍őTCY(1024*64)ŌŒ肵ĂB
            bytesData(3) = 0 'āAłőlŒƂB
            Return bytesData
        End Function

        'FMOo߂ɃoCgf[^𕶎f[^ɕϊ
        Private Function convertFMO_Byte2Sjis(ByVal bytesData As Byte()) As String
            Dim stringData As String
            If bytesData.Length < 5 Then Return ""
            bytesData(0) = 32 '{͂4oCgFMOf[^̃TCYi[Ă邪
            bytesData(1) = 32 'SSPƂƂőlŌŒ肳Ă肷̂
            bytesData(2) = 32 '̒l͎QlɂȂƂĂ܂B
            bytesData(3) = 32 'ŁAXy[XɂĂĂƂŃg`ŃJbg
            stringData = System.Text.Encoding.GetEncoding(932).GetString(bytesData)
            Dim s As String
            s = stringData.Trim
            Dim i As Integer
            If s.Length < 1 Then Return ""
            i = s.LastIndexOf(vbCrLf)
            If i < 0 Then Return ""
            s = s.Substring(0, i + 2)
            i = s.IndexOf(vbNullChar)
            If i < 0 Then Return s
            Return s.Substring(0, i)
        End Function

    End Class
End Namespace

